---
title: ContentIndex
slug: Web/API/ContentIndex
tags:
  - Content
  - Index
  - Interface
  - PWA
  - content index
  - content indexing
---
<div>{{draft}}{{DefaultAPISidebar("Content Index API")}}</div>

<p class="summary">The <strong><code>ContentIndex</code></strong> interface of the {{domxref('Content Index API')}} allows developers to register their offline enabled content with the browser.</p>

<h2 id="Properties">Properties</h2>

<p>There are no properties of this interface.</p>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref('ContentIndex.add()')}}</dt>
 <dd>Registers an item with the {{domxref('Content Index API','content index')}}.</dd>
 <dt>{{domxref('ContentIndex.delete()')}}</dt>
 <dd>Unregisters an item from the currently indexed content.</dd>
 <dt>{{domxref('ContentIndex.getAll()')}}</dt>
 <dd>Returns a {{jsxref('Promise')}} that resolves with an iterable list of content index entries.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Feature_Detection_and_Interface_Access">Feature Detection and Interface Access</h3>

<p>Here we get a reference to the {{domxref('ServiceWorkerRegistration')}}, then check for the <code>index</code> property, which gives us access to the content index interface.</p>

<pre class="brush: js notranslate">// reference registration
const registration = await navigator.serviceWorker.ready;

// feature detection
if ('index' in registration) {

  // Content Index API functionality
  const contentIndex = registration.index;

}
</pre>

<h3 id="Adding_to_the_Content_Index">Adding to the Content Index</h3>

<p>Here we're declaring an item in the correct format and creating an asynchronous function which uses the {{domxref('ContentIndex.add','add()')}} method to register it with the {{domxref('Content Index API','content index')}}.</p>

<pre class="brush: js notranslate">// our content
const item = {
  id: 'post-1',
  url: '/posts/amet.html',
  title: 'Amet consectetur adipisicing',
  description: 'Repellat et quia iste possimus ducimus aliquid a aut eaque nostrum.',
  icons: [{
    src: '/media/dark.png',
    sizes: '128x128',
    type: 'image/png',
  }],
  category: 'article'
};

// our asynchronous function to add indexed content
async function registerContent(data) {
  const registration = await navigator.serviceWorker.ready;

  // feature detect Content Index
	if (!registration.index) {
		return;
	}

  // register content
  try {
		await registration.index.add(data);
  } catch (e) {
    console.log('Failed to register content: ', e.message);
  }
}
</pre>

<h3 id="Retrieving_Items_Within_The_Current_Index">Retrieving Items Within The Current Index</h3>

<p>The below example shows an asynchronous function that retrieves items within the {{domxref('Content Index API','content index')}} and iterates over each entry, building a list for the interface.</p>

<pre class="brush: js notranslate">async function createReadingList() {
  // access our service worker registration
  const registration = await navigator.serviceWorker.ready;

  // get our index entries
  const entries = await registration.index.getAll();

  // create a containing element
  const readingListElem = document.createElement('div');

  // test for entries
  if (!Array.length) {

    // if there are no entries, display a message
    const message = document.createElement('p');
    message.innerText = 'You currently have no articles saved for offline reading.'

    readingListElem.append(message);

  } else {

    // if entries are present, display in a list of links to the content
    const listElem = document.createElement('ul');

    for (const entry of entries) {
      const listItem = document.createElement('li');

      const anchorElem = document.createElement('a');
      anchorElem.innerText = entry.title;
      anchorElem.setAttribute('href', entry.url);

      listElem.append(listItem);

    }

    readingListElem.append(listElem);
  }

}
</pre>

<h3 id="Unregistering_Indexed_Content">Unregistering Indexed Content</h3>

<p>Below is an asynchronous function, that removes an item from the {{domxref('Content Index API','content index')}}.</p>

<pre class="brush: js notranslate">async function unregisterContent(article) {

  // reference registration
  const registration = await navigator.serviceWorker.ready;

  // feature detect Content Index
  if (!registration.index)
    return;

  // unregister content from index
  await registration.index.delete(article.id);
}
</pre>

<p>All the above methods are available within the scope of the {{domxref('ServiceWorker','service worker')}}. They are accessible from the {{domxref('WorkerGlobalScope.self')}} property:</p>

<pre class="brush: js notranslate">// service worker script

self.registration.index.add(item);

self.registration.index.delete(item.id);

const contentIndexItems = self.registration.index.getAll();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Content Index API','#content-index','ContentIndex')}}</td>
   <td>{{Spec2('Content Index API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ContentIndex")}}</p>

<h2 id="See_also">See also:</h2>

<ul>
 <li><a href="https://web.dev/content-indexing-api/">An introductory article on the Content Index API</a></li>
 <li><a href="https://contentindex.dev/">An app which uses the Content Index API to list and remove 'save for later' content</a></li>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API, along with information about Cache and CacheStorage</a></li>
</ul>
